﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.8
@EndOfDesignText@
#Event: SslIssueFixed(Fixed As Boolean)

Sub Class_Globals
	Private mCallback As Object
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Callback As Object)
	mCallback = Callback
End Sub

Public Sub TryToFix
	Dim jo As JavaObject
	jo.InitializeStatic("com.google.android.gms.security.ProviderInstaller")
	Dim context As JavaObject
	context.InitializeContext
	
	DisableStrictMode

	Dim listener As Object = jo.CreateEventFromUI("com.google.android.gms.security.ProviderInstaller.ProviderInstallListener", _
		"ProviderInstall", Null)
	Log("Installing security provider if needed...")
	jo.RunMethod("installIfNeededAsync", Array(context, listener))
End Sub

Private Sub DisableStrictMode
	Dim jo As JavaObject
	jo.InitializeStatic("android.os.Build.VERSION")
	If jo.GetField("SDK_INT") > 9 Then
		Dim policy As JavaObject
		policy = policy.InitializeNewInstance("android.os.StrictMode.ThreadPolicy.Builder", Null)
		policy = policy.RunMethodJO("permitAll", Null).RunMethodJO("build", Null)
		Dim sm As JavaObject
		sm.InitializeStatic("android.os.StrictMode").RunMethod("setThreadPolicy", Array(policy))
	End If
End Sub

Private Sub ProviderInstall_Event (MethodName As String, Args() As Object)
	Dim Fixed As Boolean
	
	If MethodName = "onProviderInstalled" Then
		Log("Provider installed successfully")
		Fixed = True
	Else
		Log("Error installing provider: " & Args(0))
		Fixed = False
	End If

	CallSubDelayed2(mCallback, "SslIssueFixed", Fixed)
End Sub